/*-*-C-*-*/

import java.awt.*;
import java.io.*;
import java.lang.StringBuffer;
import java.util.Hashtable;
import java.util.Vector;

public abstract class FileManager {
  public static String workingdir;
  static String lastfile;
  static int outnum = 0;
  public final static Hashtable settings = new Hashtable();
  public final static Hashtable intparams = new Hashtable();
  final static Vector aspect = new Vector();
  public static ParFrame stdpar;
  final static String cfgfile="filmer.cfg";
  static boolean init = false;

  static void init() {
    StreamTokenizer in;
    String temp, temp2;
    ParFrame tempframe;
    BufferedReader aspectfile;

    try {
      in = new StreamTokenizer(new FileReader(cfgfile));
      in.lowerCaseMode(true);
      in.ordinaryChars(48, 57);
      in.ordinaryChar(45);
      in.ordinaryChar(43);
      in.wordChars(43, 122);
      while (in.nextToken() != StreamTokenizer.TT_EOF) {
	/*System.out.println(in.sval);*/
	if (in.sval != null) {
	  if (in.sval.equals("<integer_parameters>")) {
	    getIntParams(in);
	  } else {
	    temp2 = in.sval;
	    in.nextToken();
	    temp = in.sval;
	    /*System.out.println("Reading key:" + temp2 + " value:" + temp);*/
	    settings.put(temp2, temp);
	  }
	}
      }
    } catch (FileNotFoundException e) {
      System.out.println("Can't find settings file:" + cfgfile);
    } catch (IOException e) {
      System.out.println("Error reading file:" + cfgfile + " " + e);
    }

    try {
      aspectfile = new BufferedReader(new FileReader("aspect.par"));
      tempframe = new ParFrame();
      while (tempframe.read(aspectfile)) {
	if (tempframe.getval("name").equals("defaults")) {
	  stdpar = tempframe;
	} else {
	  aspect.addElement(tempframe);
	}
	tempframe = new ParFrame();
      }
      aspectfile.close();
    } catch (FileNotFoundException e) {
      System.out.println("Fatal error: Couldn't find file aspect.par");
    } catch (IOException e) {
      System.out.println("Error reading file:aspect.par " + e);
    }
  }

  public static String[] aspects() {
    check();

    int i;
    String retval[] = new String[aspect.size()];
    for (i =0; i < aspect.size(); i++) {
      retval[i] = ((ParFrame)FileManager.aspect.elementAt(i)).name();
    }
    return retval;
  }

  static synchronized void check() {
    if (!init) {
      init = true;
      init();
    }
  }

  static int intLookup(String key) {
    check();
    try {
      return Integer.parseInt((String)settings.get(key));
    } catch (NumberFormatException e) {
      System.out.println("NumberFormatException while trying to read integer" +
			 " parameter:" + key + " value:" + settings.get(key));
      e.printStackTrace();
      return 0;
    }
  }

  static String lookup(String key) {
    check();
    return (String)settings.get(key);
  }
  
  static void getIntParams(StreamTokenizer in) throws IOException {
    check();
    while(in.nextToken() != StreamTokenizer.TT_EOF &&
	  !in.sval.equals("</integer_parameters>")) {
      intparams.put(new String(in.sval), new String(in.sval));
    }
  }

  public static String getFile(Frame parent, String filter, String title) {
    FileDialog ask;

    check();

    /*System.out.println("FileManager.getfile Throwing away filter:"+filter);*/
    ask = new FileDialog(parent, title, FileDialog.LOAD);
    ask.show();
    return ask.getFile();
  }

  public static String putFile(Frame parent, String filter, String title) {
    FileDialog ask;

    check();

    /*System.out.println("FileManager.getfile Throwing away filter:"+filter);*/
    ask = new FileDialog(parent, title, FileDialog.SAVE);
    ask.show();
    return ask.getFile();
  }

  public static String getNextOut() {
    
    check();

    File nextout = new File("fmr" + padNum(outnum++, 5) + ".gif");
    /*System.out.println("NextOut:" + nextout.getAbsolutePath());*/
    return nextout.getName();
  }

  public static String padNum(int num, int digits) {
    int i;

    check();
    StringBuffer padded = new StringBuffer().append(num);
    for (i = padded.length(); i < digits; i++) {
      padded.insert(0, '0');
    }
    return padded.toString();
  }

  public static void resetPreview() {
    String[] files;
    int i;

    check();
    files = new File(".").list(new TempFilter("fmr"));
    for (i=0; i< files.length; i++) {
      /*System.out.println("Deleting:" + files[i]);*/
      new File(files[i]).delete();
    }
  }

  public static void resetFilm() {
    String[] files;
    int i;

    check();
    files = new File(".").list(new TempFilter("tmp"));
    for (i=0; i< files.length; i++) {
      /*System.out.println("Deleting:" + files[i]);*/
      new File(files[i]).delete();
    }
  }
}
