/*-*-C-*-*/

import java.awt.*;
import java.awt.Image;
import sun.awt.image.*;

/**
 *  Thank you for help in loading non-cached images:
 *
 *  David Erb erb@dtack.com 
 *  http://www.dtack.com/shingle.html
 */
public class ImageCanvas extends Canvas {
  Image image = null;
  MediaTracker tracker = new MediaTracker(this);
  int size;

  public ImageCanvas(String filename) {
    this(filename, 1);
  }

  public ImageCanvas(String filename, int s) {

    /* Undocumented class prevents caching of image data */
    FileImageSource source = new FileImageSource(filename); 

    image = Toolkit.getDefaultToolkit().createImage(source);
    if (image == null) {
      System.out.println("image is null");
      setBackground(Color.red);
    }
    tracker.addImage(image, 0);

    try {
      tracker.waitForAll();
    } catch (InterruptedException ex) {
      System.out.println("ParFrame.setImage " + ex);
      setBackground(Color.red);
    }

    tracker.removeImage(image);
    size = s;
    repaint();
  }

  public Dimension getPreferredSize() {
    if (image != null) {
      return new Dimension((size * image.getWidth(this)), 
			   (size * image.getHeight(this)));
    } else {
      return new Dimension(10, 10);
    }
  }

  public void update(Graphics g) {
    paint(g);
  }

  public void paint(Graphics g) {
    if (image != null) {
      int iwidth = image.getWidth(this) * size;
      int iheight = image.getHeight(this) * size;
      int x = Math.max(0, (getBounds().width - iwidth) / 2);
      int y = Math.max(0, (getBounds().height - iheight) / 2);

      g.drawImage(image, x, y, iwidth, iheight, this);
    }
  }
}
