/*-*-C-*-*/

import java.awt.*;
import java.awt.event.*;

public class MapControls extends Panel {
  IntField rotation, speed, bands;
  Checkbox issmart;
  Panel p, q;
  MapMaker smart = new MapMaker();
  
  public MapControls() {
    Label temp;

    setLayout(new BorderLayout());
    add("Center", q = new Panel());
    q.setLayout(new BorderLayout());
    q.add("North", p = new Panel());

    p.setLayout(new GridLayout(7, 1, 4, 4));

    p.add(new Label("Map Rotation:"));
    p.add(rotation = new IntField(FileManager.intLookup("<rotation>")));
    
    p.add(issmart = new Checkbox("Smart map"));
    if (FileManager.intLookup("<smart_on>") == 1) {
      issmart.setState(true);
    } else {
      issmart.setState(false);
    }

    p.add(new Label("Smart speed:"));
    p.add(speed = new IntField(FileManager.intLookup("<smart_speed>"), 1, 50));
    
    p.add(new Label("Smart bands:"));
    p.add(bands = new IntField(FileManager.intLookup("<smart_bands>"), 
			       1, 100));
  }

  public void setSensitive(boolean on) {
    rotation.setEnabled(on);
    issmart.setEnabled(on);
    speed.setEnabled(on);
    bands.setEnabled(on);
  }

  public MapMaker getMapMaker() {
    smart.setSpeed(getSpeed());
    smart.setBands(getBands());
    return smart;
  }

  public boolean isSmart() {
    return issmart.getState();
  }

  public void setRotation(int i) {
    rotation.setInt(i);
  }

  public int getRotation() {
    return rotation.getInt();
  }

  public void setSpeed(int i) {
    smart.setSpeed(i);
    speed.setInt(i);
  }

  public int getSpeed() {
    return speed.getInt();
  }

  public void setBands(int i) {
    smart.setBands(i);
    bands.setInt(i);
  }

  public int getBands() {
    return bands.getInt();
  }
}


