/*-*-C-*-*/

import java.awt.*;
import java.io.*;

public class RenderClient extends Renderer {
  public final static int GET_NEXT_FRAME = 0;
  public final static int DONE_WITH_FRAME = 1;
  String servername;
  int portnum;
  
  public RenderClient(String s) {
    super(null, null);

    portnum = FileManager.intLookup("<server_port>");
    servername = s;
  }

  public void doneWithFrame() {
    Connection server = null;

    try {
      server = new Connection();
      server.connect(servername, portnum);
      server.out.writeInt(DONE_WITH_FRAME);
      server.out.writeInt(framenum);
    } catch (Exception ex) {
      System.out.println("Could not connect to host:" + servername +
			 " port:" + portnum);
      System.out.println(ex);
      server.disconnect();
      quit();
    }
  }

  public ParFrame getNextFrame() {
    Connection server = null;
    ParFrame frame = null;

    try {
      server = new Connection();
      server.connect(servername, portnum);
      server.out.writeInt(GET_NEXT_FRAME);
      aspect = server.in.readLine();
      framenum = server.in.readInt();
      frame = new ParFrame();
      frame.read(new BufferedReader(new InputStreamReader(server.in)));
      server.disconnect();
    } catch (EOFException ex) {
      System.out.println("Server hung up - film is complete");
      quit();
    } catch (Exception ex) {
      System.out.println("Could not connect to host:" + servername +
			 " port:" + portnum);
      System.out.println(ex);
      server.disconnect();
      quit();
    }
    return frame;
  }

  public boolean handleEvent(Event e) {
    /*System.out.println("handleEvent:"+e);*/
    if (e.id == 201) {
      System.out.println("Destroy!");
      quit();
    }
    return super.handleEvent(e);
  }

  public void quit() {
    Runtime.getRuntime().exit(0);
  }

  public static void main(String argv[]) {
    RenderClient r;
    String servername = FileManager.lookup("<server_name>");

    if (argv.length < 1 && servername == null) {
      System.out.println("Please specify server name on command line" + 
			 " or in filmer.cfg file");
    } else {
      if (argv.length >= 1) {
	r = new RenderClient(argv[0]);
      } else {
	r = new RenderClient(servername);
      }
      r.start();
    }
  }
}
