/*-*-C-*-*/

import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class Renderer extends Frame implements Runnable, WindowListener {
  RenderMan manager;
  Thread t = null;
  String aspect;
  boolean firsttime=true;
  Image image = null;
  int framenum;
  MediaTracker tracker = new MediaTracker(this);
  ImageCanvas bitmap;

  public Renderer(RenderMan man, String a) {
    setBackground(Color.black);
    setLayout(new BorderLayout());
    /*setSize(initialsize);*/
    setResizable(false);
    manager = man;
    aspect = a;
  }

  public void run() {
    ParFrame frame;

    show();
    while ( t == Thread.currentThread() && 
	    (frame = getNextFrame()) != null ) {
      setTitle("Rendering - Frame " + frame.name());
      if ( (new File(frame.get("savename").value())).exists() || 
	   frame.calc(aspect)) {
	setImage(frame);
	System.gc();
	doneWithFrame();
      }
      System.gc();
    }
    frame = null;
    manager = null;
    setVisible(false);
  }

  public ParFrame getNextFrame() {
    framenum = manager.getNextFrame();
    if (framenum == -1) {
      return null;
    } else {
      return manager.frames[framenum];
    }
  }

  public void doneWithFrame() {
    manager.doneWithFrame(framenum);
  }

  public synchronized void start() {
    if (t == null) {
      t = new Thread(this);
      t.start();
    }     
  }

  public synchronized void stop() {
    t = null;
    setTitle("Stopping...");
  }

  public void setImage(ParFrame frame) {
    removeAll();
    add("Center", new ImageCanvas(frame.get("savename").value(), 1));
    /*add("South", frame.map);*/
    add("South", new Sic(MetaMap.mapToImage(frame.getval("colors"), 10)));
    pack();
    doLayout();
  }

  /*
  public boolean handleEvent(Event e) {
    if (e.id == 201) {
      if (manager != null) {
	manager.stop();
      }
    }
    return super.handleEvent(e);
  }
  */

  public void windowClosing(WindowEvent e) { 
    if (manager != null) {
      manager.stop();
    }
  }
  public void windowActivated(WindowEvent e) {}
  public void windowClosed(WindowEvent e) {}
  public void windowDeactivated(WindowEvent e) {}
  public void windowDeiconified(WindowEvent e) {}
  public void windowIconified(WindowEvent e) {}
  public void windowOpened(WindowEvent e) {}
}
